#ifndef __MX3080_H__
#define __MX3080_H__

#include "Arduino.h"
#include "SoftwareSerial.h"
#include <avr/pgmspace.h>

class MX3080 {
    using ProcessCommand = void (*)(const String &);

 public:
    MX3080(SoftwareSerial &uart, uint32_t baud, ProcessCommand cb);
    ProcessCommand processCommand;
    int print(const String &s);
    int println(const String &s);
    int available(void);
    int read();
    int16_t* hex2int16(char* string);
    void readIfAvailable(void);
    void eventLooper(void);
    void handleWifiAction(const String &wifiMsg);
    void kick(void);
    void restart(void);
    int getRssi(void);
    void skPair(void);
    void skStat(char *csv);
    boolean wifiStringComplete = false;
    String wifiString = "";
    int channel = 0;
    int rssi = 0;
    bool shouldSendReport = false; // pass sensor data to mico
    bool shouldUpdateDevice = false; // pass wifi command to pc

 private:
    void rx_empty(void);
    SoftwareSerial *m_puart; /* The UART to communicate with MX3080 */
};

#endif /* #ifndef __MX3080_H__ */

