@mainpage

# MX3080

An MX3080 library for Arduino providing an easy-to-use way to manipulate MX3080.

# How to get started

On the home page of API documentation, the tabs of Examples, Classes and Modules
will be useful for Arduino lovers.

# API List

    bool 	kick (void) : Verify MX3080 whether live or not.

    bool 	restart (void) : Restart MX3080 by "AT+REBOOT".

    String 	getVersion (void) : Get the version of AT Command Set.

# Mainboard Requires

  - RAM: not less than 2KBytes
  - Serial: one serial (HardwareSerial or SoftwareSerial) at least

# Suppported Mainboards

  - Arduino UNO and its derivatives

# Using SoftwareSerial

If you want to use SoftwareSerial to communicate with MX3080, you need to modify
the line in file `MX3080.h`:

    //#define MX3080_USE_SOFTWARE_SERIAL

After modification, it should be:

    #define MX3080_USE_SOFTWARE_SERIAL


# Hardware Connection

MX3080 library only needs an uart for hardware connection. All communications
are done via uart. In each example, you must specify the uart used by mainboard
to communicate with MX3080 flashed AT firmware.

## UNO

To use SoftwareSerial, `mySerial` will be used if you create an object (named wifi)
of class MX3080 in your code like this:

    #include "MX3080.h"
    #include <SoftwareSerial.h>

    SoftwareSerial mySerial(3, 2); /* RX:D3, TX:D2 */
    MX3080 wifi(mySerial);

The connection should be like these:

    MX3080_TX->RX(D3)
    MX3080_RX->TX(D2)
    MX3080_CH_PD->3.3V
    MX3080_VCC->3.3V
    MX3080_GND->GND

# Attention

The size of data from MX3080 is too big for arduino sometimes, so the library can't
receive the whole buffer because the size of the hardware serial buffer which is
defined in HardwareSerial.h is too small.

Open the file from `\arduino\hardware\arduino\avr\cores\arduino\HardwareSerial.h`.
See the follow line in the HardwareSerial.h file.

    #define SERIAL_BUFFER_SIZE 64

The default size of the buffer is 64. Change it into a bigger number, like 256 or more.
